import 'package:dshell/dshell.dart';
import 'package:meta/meta.dart';

import 'certbot.dart';

void http_auth_renewal({
  @required String fqdn,
  @required String tld,
  @required String emailaddress,
  bool staging = false,
  bool debug = true,
}) {
  var workDir = _createDir(Certbot().letsEncryptWorkPath);
  var logDir = _createDir(Certbot().letsEncryptLogPath);
  var configDir = _createDir(Certbot().letsEncryptConfigPath);

  var certbot = 'certbot certonly --nginx'
      ' --manual '
      ' --preferred-challenges=http01 '
      ' -m $emailaddress  '
      ' -d $fqdn '
      ' --agree-tos '
      ' --manual-public-ip-logging-ok '
      ' --non-interactive '
      ' --work-dir=$workDir '
      ' --config-dir=$configDir '
      ' --logs-dir=$logDir ';

  if (staging) certbot += ' --staging ';

  // var shell = ShellDetection().identifyShell();
  // if (!shell.isPrivilegedUser) {
  //   /// var password = ask(prompt: '[sudo] password for ${shell.loggedInUser}: ');
  //   var password = 'udoo-not10**';
  //   // certbot = 'echo $password | sudo -S $certbot';
  // }

  certbot.start(
      runInShell: true,
      nothrow: true,
      progress:
          Progress((line) => print(line), stderr: (line) => printerr(line)));
}

String _createDir(String dir) {
  if (!exists(dir)) {
    createDir(dir, recursive: true);
  }
  return dir;
}
