import 'package:dshell/dshell.dart';
import 'package:meta/meta.dart';
import 'container.dart';

class Containers {
  static const _self = Containers._internal();

  const Containers._internal();

  factory Containers() => _self;

  List<Container> get containers {
    var lines = 'docker container ls'.toList(skipLines: 1);

    var containers = <Container>[];

    for (var line in lines) {
      var parts = line.split(RegExp(r'\s+'));
      var containerid = parts[0];
      var image = parts[1];
      var command = parts[2];
      var created = parts[3];
      var status = parts[4];
      var ports = parts[4];
      var names = parts[4];

      var container = Container(
          containerid: containerid,
          image: image,
          command: command,
          created: created,
          status: status,
          ports: ports,
          names: names);
      containers.add(container);
    }
    return containers;
  }

  bool existsByContainerId({@required String containerid}) =>
      findByContainerId(containerid: containerid) != null;

  Container findByContainerId({@required String containerid}) {
    var list = containers;

    for (var container in list) {
      if (containerid == container.containerid) {
        return container;
      }
    }
    return null;
  }

  List<Container> findByImage({@required String image}) {
    var list = containers;
    var matches = <Container>[];

    for (var container in list) {
      if (image == container.image) {
        matches.add(container);
      }
    }
    return matches;
  }
}
