import 'package:dshell/dshell.dart';
import 'package:meta/meta.dart';
import 'image.dart';

class Images {
  static const _self = Images._internal();

  const Images._internal();

  factory Images() => _self;

  List<Image> get images {
    var lines = 'docker images'.toList(skipLines: 1);

    var images = <Image>[];

    for (var line in lines) {
      var parts = line.split(RegExp(r'\s+'));
      var repository = parts[0];
      var tag = parts[1];
      var imageid = parts[2];
      var created = parts[3];
      var size = parts[4];

      var image = Image(
          repository: repository,
          tag: tag,
          imageid: imageid,
          created: created,
          size: size);
      images.add(image);
    }
    return images;
  }

  bool existsByImageId({@required String imageid}) =>
      findByImageId(imageid: imageid) != null;

  bool existsByName({@required String repository, @required String tag}) =>
      findByName(repository: repository, tag: tag) != null;

  Image findByImageId({@required String imageid}) {
    var list = images;

    for (var image in list) {
      if (imageid == image.imageid) {
        return image;
      }
    }
    return null;
  }

  Image findByName({@required String repository, @required String tag}) {
    var list = images;

    for (var image in list) {
      if (repository == image.repository && tag == image.tag) {
        return image;
      }
    }
    return null;
  }
}
